/**
 * Breadth First Search - BFS
 *
 * Complexity (Time): O(|V| + |E|)
 * Complexity (Space): O(|V| + |E|)
 */

bool cont[MAX];
vector<int> graph[MAX];

void bfs(int x) {
  queue<int> Q;

  Q.push(x);
  cont[x] = true;

  while (!Q.empty()) {
    int v = Q.front();
    Q.pop();
    cont[v] = true;

    for (auto i : graph[v])
      if (!cont[i])
        Q.push(i);
  }
}
